--No Chilling Summons by John Nelson
--
--This addon allows you to block the "A Chilling Summons" Shadowland quest. 
--
--

--Constants
--
NCS_A_CHILLING_SUMMONS_HORDE=61874
NCS_A_CHILLING_SUMMONS_ALLIANCE=60545
NCS_QUEST_LOG_CHANGED="UNIT_QUEST_LOG_CHANGED"
NCS_PLAYER_ENTERING_WORLD="PLAYER_ENTERING_WORLD"
NCS_BLIZZARD_TALKING_HEAD_UI="Blizzard_TalkingHeadUI"
NCS_TALKINGHEAD_REQUESTED="TALKINGHEAD_REQUESTED"
NCS_ADDON_LOADED="ADDON_LOADED"
NCS_QUEST_TEXT="the veil between our world and the Shadowlands has been sundered"
NCS_FORTYSEVEN=47
NCS_HELP1="Type '/NCS' to get the current settings."
NCS_HELP2="Type '/NCS Default' to set to default."
NCS_HELP3="Type '/NCS Shadowlands' to toggle the 'No Chilling Summons' blocker off and on."
NCS_HELP4="Type '/NCS Head' to toggle the talking heads blocker off and on."
NCS_HELP5="Type '/NCS Text' to toggle Morgraine's talking head text off and on."
NCS_HELP6="Type '/NCS Off' to turn off the addon."
NCS_HELP7="Type '/NCS On' to turn on the addon."
NCS_SHADOWLANDS="SHADOWLANDS"
NCS_HEAD="HEAD"
NCS_TEXT="TEXT"
NCS_HELP="HELP"
NCS_ON="ON"
NCS_OFF="OFF"
NCS_DEFAULT="DEFAULT"
NCS_TALKINGHEAD_VO_ALLIANCE=164945
NCS_TALKINGHEAD_VO_HORDE=164946

NCS_blnHOOKED=false

--EVENT HANDLING--
--
--frames for event handling
--
local NCS_Frame = CreateFrame("Frame")
local NCS_TalkingHeadsFrame = CreateFrame("Frame")



--triggered by events 
--
local function onLogChangedEnteredWorldEvent(self, event, ...)

	--if quest log changed OR player entered the world
	--abandon the specific quest
	--
	if (event==NCS_QUEST_LOG_CHANGED or event==NCS_PLAYER_ENTERING_WORLD) then 
		
		--close the quest
		--
		NCS_QuickClose()

	end

end

--triggered by talking head requested and  
--addon loaded events
--
local function onTalkingHeadEvent(self, event, arg1, ...)

	--if talking head 
	--if the event is "TALKINGHEAD_REQUESTED" or
	--if the event is "ADDON_LOADED" along with addon name == "BLIZZARD_TALKING_HEAD_UI"
	--
	if((event==NCS_TALKINGHEAD_REQUESTED) or (arg1==NCS_BLIZZARD_TALKING_HEAD_UI)) then

		--if NCS is set to ON
		--
		if NCSON then
			--if not blocking talking heads
			--just get out of here
			-- 
			if not BLOCKTALKINGHEAD then return end

		else

			--if NCS is set to OFF
			--get out of here
			--
			return

		end
		
		--If we made it this far, we can stop the talking head
		--hook the PlayCurrent function from the TalkingHeadFrame
		--close the talking head immediately!
		--
		if NCS_blnHOOKED then
			TalkingHeadFrame_PlayCurrent = function(...)
    				-- Do something different
        			local displayInfo, cameraID, vo, duration, lineNumber, numLines, name, text, isNewTalkingHead, textureKit = C_TalkingHead.GetCurrentLineInfo()
				--DEFAULT_CHAT_FRAME:AddMessage("text: " .. vo)
				if((vo==NCS_TALKINGHEAD_VO_ALLIANCE) or (vo==NCS_TALKINGHEAD_VO_HORDE)) then
					TalkingHeadFrame_CloseImmediately()
				end
			end		
		else
			hooksecurefunc("TalkingHeadFrame_PlayCurrent", function(...)
        			local displayInfo, cameraID, vo, duration, lineNumber, numLines, name, text, isNewTalkingHead, textureKit = C_TalkingHead.GetCurrentLineInfo()
        			--print("initial: ", displayInfo, cameraID, vo, duration, lineNumber, numLines, name, text, isNewTalkingHead, textureKit)
				--DEFAULT_CHAT_FRAME:AddMessage("text: " .. vo)
				if((vo==NCS_TALKINGHEAD_VO_ALLIANCE) or (vo==NCS_TALKINGHEAD_VO_HORDE)) then
					TalkingHeadFrame_CloseImmediately()
				end
			end)
			NCS_blnHOOKED=true
		end

		--self:UnregisterEvent(event)

	end

end

--register quest log changed and player entering world events
--
function NCS_RegisterQuestBlockEvents()

	--register events
	--
	NCS_Frame:RegisterEvent(NCS_QUEST_LOG_CHANGED)
	NCS_Frame:RegisterEvent(NCS_PLAYER_ENTERING_WORLD)
	NCS_Frame:SetScript("OnEvent", onLogChangedEnteredWorldEvent)
end

--register talking head requested event
--register addon loaded event
--
function NCS_RegisterTalkingHeadEvents()

	NCS_TalkingHeadsFrame:RegisterEvent(NCS_TALKINGHEAD_REQUESTED)
	NCS_TalkingHeadsFrame:RegisterEvent(NCS_ADDON_LOADED)
	NCS_TalkingHeadsFrame:SetScript("OnEvent", onTalkingHeadEvent)

end

--unregister talking head requested event
--unregister addon loaded
--
function NCS_UnRegisterTalkingHeadEvents()

	NCS_TalkingHeadsFrame:UnregisterEvent(NCS_TALKINGHEAD_REQUESTED)
	NCS_TalkingHeadsFrame:UnregisterEvent(NCS_ADDON_LOADED)

end

--call the register events functions
--
NCS_RegisterQuestBlockEvents()
NCS_RegisterTalkingHeadEvents()

--if the current player's level is greater than 47
--return true
--otherwise return false
--SAVING THIS FUNCTIONALITY FOR LATER, IF AT ALL!!
--
function NCS_GreaterThanFortySeven()

	--get my character's level
	--
	NCS_Level = UnitLevel("player") 
	if (NCS_Level > NCS_FORTYSEVEN) then
		return true
	end
	return false

end

--Do this on load of the addon
--
function NCS_NoChillingSummons_OnLoad()

	--display on load
	--
	DEFAULT_CHAT_FRAME:AddMessage("No Chilling Summons Version 1.25 Loaded. Type '/ncs help' for more info.", 0.0, 0.9, 0.0)

	--if the values are nil, most likely it is the first time running
	--set to default values
	--
	if(BLOCKSUMMONS==nil) then 
		NCS_SetDefaults()
	end

	--set slash command
	--
	SlashCmdList["NCS"] = NCS_SlashCmdHandler;
	SLASH_NCS1 = "/ncs";

	NCS_blnHOOKED=false

end

--this is the slash command function that is called
--parameters--
--signature: the text following the /ncs slash command
--
function NCS_SlashCmdHandler(signature)

	--unregister and re-register the talking head events
	--
	NCS_UnRegisterTalkingHeadEvents()
	NCS_RegisterTalkingHeadEvents()

	--no parameter signature
	--
	if(signature=="") then
		NCS_DisplaySettings()
		return
	end
 	
	--toggle the blocking of 'a chilling summons' quest on/off
	--
	if(string.upper(signature)==NCS_SHADOWLANDS) then 	
		BLOCKSUMMONS=not BLOCKSUMMONS
		NCS_DisplaySettings()
		NCS_QuickClose()
		return
	end

	--toggle talking heads on/off
	--
	if(string.upper(signature)==NCS_HEAD) then 	
		BLOCKTALKINGHEAD=not BLOCKTALKINGHEAD
		ReloadUI()
		return
	end

	--toggle talking heads text for 'a chilling summons' on/off
	--
	if(string.upper(signature)==NCS_TEXT) then 	
		BLOCKTALKINGHEADTEXT=not BLOCKTALKINGHEADTEXT
		NCS_DisplaySettings()
		return
	end

	--toggle this addon off
	--
	if(string.upper(signature)==NCS_OFF) then 	
		NCSON=false
		ReloadUI()
		return
	end

	--toggle this addon on
	--
	if(string.upper(signature)==NCS_ON) then 	
		NCSON=true
		NCS_DisplaySettings()
		NCS_QuickClose()
		return
	end

	--set the addon to default
	--
	if(string.upper(signature)==NCS_DEFAULT) then 	
		NCS_SetDefaults()
		NCS_QuickClose()
		ReloadUI()
		return
	end

	--display the addon help
	--
	if(string.upper(signature)==NCS_HELP) then 	
		DEFAULT_CHAT_FRAME:AddMessage("==========NCS Help==========")
		DEFAULT_CHAT_FRAME:AddMessage(NCS_HELP1)
		DEFAULT_CHAT_FRAME:AddMessage(NCS_HELP2)
		DEFAULT_CHAT_FRAME:AddMessage(NCS_HELP3)
		DEFAULT_CHAT_FRAME:AddMessage(NCS_HELP4)
		DEFAULT_CHAT_FRAME:AddMessage(NCS_HELP5)
		DEFAULT_CHAT_FRAME:AddMessage(NCS_HELP6)
		DEFAULT_CHAT_FRAME:AddMessage(NCS_HELP7)
		DEFAULT_CHAT_FRAME:AddMessage("==========END Help==========")
		return
	end

	--display if the argument is not recognized
	--
	DEFAULT_CHAT_FRAME:AddMessage(signature .. " not recognized as an argument.")

end

--close the 'a chilling summons' quest
--
function NCS_QuickClose()
	
	--if blocking and the addon is on
	--
	if(BLOCKSUMMONS and NCSON) then
		NCS_AbandonThisQuest(NCS_A_CHILLING_SUMMONS_HORDE)
		NCS_AbandonThisQuest(NCS_A_CHILLING_SUMMONS_ALLIANCE)
	end

end

--addon default values
--
function NCS_SetDefaults()

	BLOCKSUMMONS=true
	BLOCKTALKINGHEAD=true
	BLOCKTALKINGHEADTEXT=true
	NCSON=true

end

--display the current settings
--
function NCS_DisplaySettings()
	DEFAULT_CHAT_FRAME:AddMessage("==========Current NCS Settings==========")
	DEFAULT_CHAT_FRAME:AddMessage("Block the 'No Chilling Summons' quest: " .. tostring(BLOCKSUMMONS))
	DEFAULT_CHAT_FRAME:AddMessage("Block talking heads: " .. tostring(BLOCKTALKINGHEAD))
	DEFAULT_CHAT_FRAME:AddMessage("Block 'No Chilling Summons' text: " .. tostring(BLOCKTALKINGHEADTEXT))
	DEFAULT_CHAT_FRAME:AddMessage("No Chilling Summons on: " .. tostring(NCSON))
	DEFAULT_CHAT_FRAME:AddMessage("==========END Settings==========")
end


--function to abandon quest by quest ID
--	parameter INT quest ID
--
function NCS_AbandonThisQuest(NCS_Quest_ID)
	C_QuestLog.SetSelectedQuest(NCS_Quest_ID)
	C_QuestLog.RemoveQuestWatch(NCS_Quest_ID)  --removes quest from tracking window
	C_QuestLog.SetSelectedQuest(NCS_Quest_ID)  --added for version 1.21 to fix a bug where it would auto-abandon an open quest if the SL quest was abandoned
	C_QuestLog.SetAbandonQuest()
	C_QuestLog.AbandonQuest()  --abandons the quest
end

--blocks the talking head text
--thanks Gregory from WoW Addon Discord chat
--
local NCS_Chat = DEFAULT_CHAT_FRAME
local NCS_Add = NCS_Chat.AddMessage
NCS_Chat.AddMessage = function(self, text, r, g, b, id, ...)
	if text then
        	if (string.find(text, NCS_QUEST_TEXT)) then 
			--if NCS_GreaterThanFortySeven() then

				if (BLOCKTALKINGHEADTEXT and NCSON) then
					return 
				end
			--end
		end
        end
    	NCS_Add(self, text, r, g, b, id, ...)
end
